<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Izg 2018 - 2019, lab 6.: student/camera.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Izg 2018 - 2019, lab 6.
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_df997ef5cbe81af8266600b381d65502.html">student</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">camera.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file contains function declarations for orbit camera manipulator.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;<a class="el" href="fwd_8h_source.html">student/fwd.h</a>&gt;</code><br />
</div>
<p><a href="camera_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a9ae73100cfea5804280d19ffbafb7f07"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="camera_8h.html#a9ae73100cfea5804280d19ffbafb7f07">frustum_Mat4</a> (<a class="el" href="structMat4.html">Mat4</a> *const output, float const left, float const right, float const bottom, float const top, float const near, float const far)</td></tr>
<tr class="memdesc:a9ae73100cfea5804280d19ffbafb7f07"><td class="mdescLeft">&#160;</td><td class="mdescRight">This functions initializes matrix to general perspective matrix.  <a href="#a9ae73100cfea5804280d19ffbafb7f07">More...</a><br /></td></tr>
<tr class="separator:a9ae73100cfea5804280d19ffbafb7f07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8da2a3e8adaa5a3515f7eecb5eb50de4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="camera_8h.html#a8da2a3e8adaa5a3515f7eecb5eb50de4">perspective_Mat4</a> (<a class="el" href="structMat4.html">Mat4</a> *const output, float const fovy, float const aspect, float const near, float const far)</td></tr>
<tr class="memdesc:a8da2a3e8adaa5a3515f7eecb5eb50de4"><td class="mdescLeft">&#160;</td><td class="mdescRight">This functions initializes matrix to perspective matrix.  <a href="#a8da2a3e8adaa5a3515f7eecb5eb50de4">More...</a><br /></td></tr>
<tr class="separator:a8da2a3e8adaa5a3515f7eecb5eb50de4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9401b0642b138bef78433f5cedc6cea5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="camera_8h.html#a9401b0642b138bef78433f5cedc6cea5">cpu_computeOrbitCamera</a> (<a class="el" href="structMat4.html">Mat4</a> *const <a class="el" href="quadExample_8c.html#ae64ebe4c77936fc93d161b97bd8e96df">viewMatrix</a>, float const angleX, float const angleY, float const distance)</td></tr>
<tr class="memdesc:a9401b0642b138bef78433f5cedc6cea5"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function computes view matrix of orbit camera manipulator.  <a href="#a9401b0642b138bef78433f5cedc6cea5">More...</a><br /></td></tr>
<tr class="separator:a9401b0642b138bef78433f5cedc6cea5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee672720f53cc1451803c545a9132956"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="camera_8h.html#aee672720f53cc1451803c545a9132956">cpu_getCameraPositionFromViewMatrix</a> (<a class="el" href="structVec3.html">Vec3</a> *const <a class="el" href="student_8c.html#a2ae2553412ead34e3a4e23019d4f052e">cameraPosition</a>, <a class="el" href="structMat4.html">Mat4</a> const *const <a class="el" href="quadExample_8c.html#ae64ebe4c77936fc93d161b97bd8e96df">viewMatrix</a>)</td></tr>
<tr class="memdesc:aee672720f53cc1451803c545a9132956"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function gets camere position from view matrix.  <a href="#aee672720f53cc1451803c545a9132956">More...</a><br /></td></tr>
<tr class="separator:aee672720f53cc1451803c545a9132956"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file contains function declarations for orbit camera manipulator. </p>
<dl class="section author"><dt>Author</dt><dd>Tomáš Milet, <a href="#" onclick="location.href='mai'+'lto:'+'imi'+'le'+'t@f'+'it'+'.vu'+'tb'+'r.c'+'z'; return false;">imile<span style="display: none;">.nosp@m.</span>t@fi<span style="display: none;">.nosp@m.</span>t.vut<span style="display: none;">.nosp@m.</span>br.c<span style="display: none;">.nosp@m.</span>z</a> </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="a9401b0642b138bef78433f5cedc6cea5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void cpu_computeOrbitCamera </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structMat4.html">Mat4</a> *const&#160;</td>
          <td class="paramname"><em>viewMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>angleX</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>angleY</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>distance</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function computes view matrix of orbit camera manipulator. </p>
<div class="image">
<img src="orbit_camera.svg" alt="orbit_camera.svg"/>
<div class="caption">
orbit camera</div></div>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">viewMatrix</td><td>output matrix </td></tr>
    <tr><td class="paramname">angleX</td><td>x angle </td></tr>
    <tr><td class="paramname">angleY</td><td>y angle </td></tr>
    <tr><td class="paramname">distance</td><td>distance between camera center and focus point </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aee672720f53cc1451803c545a9132956"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void cpu_getCameraPositionFromViewMatrix </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structVec3.html">Vec3</a> *const&#160;</td>
          <td class="paramname"><em>cameraPosition</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMat4.html">Mat4</a> const *const&#160;</td>
          <td class="paramname"><em>viewMatrix</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function gets camere position from view matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">cameraPosition</td><td>output camera position </td></tr>
    <tr><td class="paramname">viewMatrix</td><td>view matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9ae73100cfea5804280d19ffbafb7f07"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void frustum_Mat4 </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structMat4.html">Mat4</a> *const&#160;</td>
          <td class="paramname"><em>output</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>left</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>right</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>bottom</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>top</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>near</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>far</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This functions initializes matrix to general perspective matrix. </p>
<div class="image">
<img src="frustum.svg" alt="frustum.svg"/>
<div class="caption">
General perspective frustum</div></div>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">output</td><td>resulting mat4 </td></tr>
    <tr><td class="paramname">left</td><td>left coord of frustum </td></tr>
    <tr><td class="paramname">right</td><td>right coord of frustum </td></tr>
    <tr><td class="paramname">bottom</td><td>bottom coord of frustum </td></tr>
    <tr><td class="paramname">top</td><td>top coord of frustum </td></tr>
    <tr><td class="paramname">near</td><td>naer coord of frustum </td></tr>
    <tr><td class="paramname">far</td><td>far coord of frustum </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8da2a3e8adaa5a3515f7eecb5eb50de4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void perspective_Mat4 </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structMat4.html">Mat4</a> *const&#160;</td>
          <td class="paramname"><em>output</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>fovy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>aspect</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>near</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>far</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This functions initializes matrix to perspective matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">output</td><td>resulting mat4 </td></tr>
    <tr><td class="paramname">fovy</td><td>field of view in y direction </td></tr>
    <tr><td class="paramname">aspect</td><td>aspect ratio - width/height of screen </td></tr>
    <tr><td class="paramname">near</td><td>near plane distance </td></tr>
    <tr><td class="paramname">far</td><td>far plane distance </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Apr 24 2019 08:37:08 for Izg 2018 - 2019, lab 6. by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
